-----------------------------------------------------------------------
--              GtkAda - Ada95 binding for Gtk+/Gnome                --
--                                                                   --
--                  Copyright (C) 2008, AdaCore                      --
--                                                                   --
-- This library is free software; you can redistribute it and/or     --
-- modify it under the terms of the GNU General Public               --
-- License as published by the Free Software Foundation; either      --
-- version 2 of the License, or (at your option) any later version.  --
--                                                                   --
-- This library is distributed in the hope that it will be useful,   --
-- but WITHOUT ANY WARRANTY; without even the implied warranty of    --
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU --
-- General Public License for more details.                          --
--                                                                   --
-- You should have received a copy of the GNU General Public         --
-- License along with this library; if not, write to the             --
-- Free Software Foundation, Inc., 59 Temple Place - Suite 330,      --
-- Boston, MA 02111-1307, USA.                                       --
--                                                                   --
--                                                                          --
--                                                                          --
--                                                                          --
--                                                                          --
--                                                                          --
--                                                                          --
-----------------------------------------------------------------------

with Glib.Object; use Glib.Object;
with System;

package body Gdk.Display_Manager is

   -------------------------
   -- Set_Default_Display --
   -------------------------

   procedure Set_Default_Display
     (Manager : Display_Manager; Display : Gdk_Display)
   is
      procedure Internal (Manager : Display_Manager; Display : System.Address);
      pragma Import (C, Internal, "gdk_display_manager_set_default_display");
   begin
      Internal (Manager, Get_Object (Display));
   end Set_Default_Display;

end Gdk.Display_Manager;
